Subject: Re: Phyr Starter

From: Christoph Hellwig <[email-masked]>
Date: Thu, 20 Jan 2022 14:39:11 +0100

On Mon, Jan 10, 2022 at 07:34:49PM +0000, Matthew Wilcox wrote:
> TLDR: I want to introduce a new data type:
> 
> struct phyr {
>         phys_addr_t addr;
>         size_t len;
> };
> 
> and use it to replace bio_vec as well as using it to replace the array
> of struct pages used by get_user_pages() and friends.

FYI, I've done a fair amount of work (some already mainline as in all
the helpers for biovec page access), some of it still waiting (switching
more users over to these helpers and cleaning up some other mess)
to move bio_vecs into a form like that.  The difference in my plan
is to have a u32 len, both to allow for flags space on 64-bit which
we might need to support things like P2P without dev_pagemap structures.

> Finally, it may be possible to stop using scatterlist to describe the
> input to the DMA-mapping operation.  We may be able to get struct
> scatterlist down to just dma_address and dma_length, with chaining
> handled through an enclosing struct.

Yes, I have some prototype could that takes a bio_vec as input and
returns an array of

struct dma_range {
	dma_addr_t	addr;
	u32		len;
}

І need to get back to it and especially back to the question if this
needs the chaining support that the current scatterlist has.